USE BadRemakes;

CREATE TABLE Actors (
	ActorId INT IDENTITY
	,Name NVARCHAR(50) NOT NULL
	,PRIMARY KEY(ActorId)
);

CREATE TABLE Directors (
	DirectorId INT IDENTITY
	,Name NVARCHAR(50) NOT NULL
	,PRIMARY KEY (DirectorId)
);

CREATE TABLE Users (
	UserId INT IDENTITY
	,Name NVARCHAR(50) NOT NULL
	,PRIMARY KEY (UserId)
);

CREATE TABLE Remakes (
	RemakeId INT IDENTITY
	,Title NVARCHAR(100) NOT NULL
	,UserId INT NOT NULL
	,DirectorId INT NOT NULL
	,PRIMARY KEY(RemakeId)
);

CREATE TABLE ActorsRemakes (
	ActorId INT NOT NULL
	,RemakeId INT NOT NULL
	,PRIMARY KEY(ActorId, RemakeId)
);

CREATE TABLE UserLikes (
	UserId INT NOT NULL
	,RemakeId INT NOT NULL
	,PRIMARY KEY (UserId, RemakeId)
);

ALTER TABLE Remakes	 
	ADD CONSTRAINT FK_Remakes_Users
	FOREIGN KEY (UserId) REFERENCES Users(UserId)

ALTER TABLE Remakes	 
	ADD CONSTRAINT FK_Remakes_Directors
	FOREIGN KEY (DirectorId) REFERENCES Directors(DirectorId)

ALTER TABLE ActorsRemakes	 
	ADD CONSTRAINT FK_ActorsRemakes_Actors
	FOREIGN KEY (ActorId) REFERENCES Actors(ActorId)

ALTER TABLE ActorsRemakes	 
	ADD CONSTRAINT FK_ActorsRemakes_Remakes
	FOREIGN KEY (RemakeId) REFERENCES Remakes(RemakeId)

ALTER TABLE UserLikes	 
	ADD CONSTRAINT FK_UserLikes_Remakes
	FOREIGN KEY (RemakeId) REFERENCES Remakes(RemakeId)

ALTER TABLE UserLikes	 
	ADD CONSTRAINT FK_UserLikes_Users
	FOREIGN KEY (UserId) REFERENCES Users(UserId)

